"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var yargs = require("yargs");
var createConfig_1 = require("./createConfig");
var executor_1 = require("./executor");
var argv = yargs
    .command('build', 'compiles package for usage in production')
    .command('watch', 'launches package in development mode with hot code reload')
    .command('test [mocha-webpack options]', 'runs package tests')
    .demandCommand(1, '')
    .help()
    .version(require('../package.json').version)
    .argv;
var cmd = argv._[0];
var config;
if (cmd === 'watch' || cmd === 'build' || cmd === 'test') {
    config = createConfig_1.default(cmd);
}
executor_1.default(cmd, config.builders, config.options);
//# sourceMappingURL=index.js.map