"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var requireModule_1 = require("../requireModule");
var JSRuleFinder_1 = require("./shared/JSRuleFinder");
var ES6Plugin = (function () {
    function ES6Plugin() {
    }
    ES6Plugin.prototype.configure = function (builder, spin) {
        if (builder.stack.hasAll(['es6', 'webpack'])) {
            var babelRule = {
                loader: requireModule_1.default.resolve('babel-loader'),
                options: {
                    cacheDirectory: spin.dev,
                    presets: [
                        requireModule_1.default.resolve('babel-preset-react'),
                        [requireModule_1.default.resolve('babel-preset-es2015'), { 'modules': false }],
                        requireModule_1.default.resolve('babel-preset-stage-0')
                    ],
                    plugins: [
                        requireModule_1.default.resolve('babel-plugin-transform-runtime'),
                        requireModule_1.default.resolve('babel-plugin-transform-decorators-legacy'),
                        requireModule_1.default.resolve('babel-plugin-transform-class-properties'),
                    ].concat(spin.dev && spin.options.reactHotLoader ? [requireModule_1.default.resolve('react-hot-loader/babel')] : []),
                    only: ['*.js'].concat(builder.stack.hasAny(['react', 'react-native']) ? ['*.jsx'] : []),
                },
            };
            if (builder.stack.hasAny('es6') && !builder.stack.hasAny('dll')) {
                builder.config = spin.merge({
                    entry: {
                        index: [requireModule_1.default.resolve('babel-polyfill')],
                    },
                }, builder.config);
            }
            var jsRule = JSRuleFinder_1.default(builder);
            jsRule.exclude = /node_modules/;
            jsRule.use = babelRule;
        }
    };
    return ES6Plugin;
}());
exports.default = ES6Plugin;
//# sourceMappingURL=ES6Plugin.js.map