"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var JSRuleFinder_1 = require("./shared/JSRuleFinder");
var ReactPlugin = (function () {
    function ReactPlugin() {
    }
    ReactPlugin.prototype.configure = function (builder, spin) {
        var stack = builder.stack;
        if (stack.hasAll(['react', 'webpack'])) {
            var jsRule = JSRuleFinder_1.default(builder);
            jsRule.test = /\.jsx?$/;
            builder.config = spin.merge(builder.config, {
                resolve: {
                    extensions: stack.hasAny('server') ?
                        [".web.js", ".web.jsx", '.js', '.jsx'] :
                        ["." + stack.platform + ".js", "." + stack.platform + ".jsx", '.native.js', '.native.jsx', '.js', '.jsx'],
                }
            });
            if (stack.hasAny('web') && !stack.hasAny('dll')) {
                for (var idx = 0; idx < builder.config.entry.index.length; idx++) {
                    if (builder.config.entry.index[idx].endsWith('index.js')) {
                        builder.config.entry.index[idx] =
                            builder.config.entry.index[idx].replace('.js', '.jsx');
                    }
                }
            }
        }
    };
    return ReactPlugin;
}());
exports.default = ReactPlugin;
//# sourceMappingURL=ReactPlugin.js.map