"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var requireModule_1 = require("../requireModule");
var JSRuleFinder_1 = require("./shared/JSRuleFinder");
var StyledComponentsPlugin = (function () {
    function StyledComponentsPlugin() {
    }
    StyledComponentsPlugin.prototype.configure = function (builder, spin) {
        var stack = builder.stack;
        if (stack.hasAll(['styled-components', 'webpack']) &&
            (stack.hasAny('web') || (stack.hasAny('server') && spin.options.ssr))) {
            var jsRule = JSRuleFinder_1.default(builder);
            jsRule.use = spin.merge(jsRule.use, {
                options: {
                    plugins: [
                        [requireModule_1.default.resolve('babel-plugin-styled-components'), { 'ssr': spin.options.ssr }],
                    ],
                },
            });
        }
    };
    return StyledComponentsPlugin;
}());
exports.default = StyledComponentsPlugin;
//# sourceMappingURL=StyledComponentsPlugin.js.map